# MWB Each - EXPERIMENTAL

[English](README_each.md)

- 追加された "MWB Each" について記載しています

- この機能は [note で公開した検討](https://note.com/bbcmc/n/n2d4765b4bd47) に使用するために制作したものです

- 一般的な情報については [README.md](README.md) を参照ください

- ＊＊＊＊注意＊＊＊＊
  
   - 実験的な拡張ですので、使用にあたってはご注意ください

![](misc/each/each_00.png)

# Additional Features / 追加された機能

- [任意比率マージ](## 任意比率マージ)
- [マルチマージ用コマンド入力窓](## マルチマージ用コマンド入力窓)
   - [使用可能な変数](### 使用可能な変数)
- [個人用プリセットファイル](## 個人用プリセットファイル)

## 任意比率マージ

- Merge Block Weighted GUI を拡張し、マージ時に U-Net の各レイヤーについて、モデルA / モデルB を**任意の割合で**合成できるようにします
  
   - UI 上に表示されているのは、モデル A と モデル B の比率のみです

- 例: 仮に右の比率でマージをする場合、IN_A_00: 0.5, IN_B_00:0.3, マージ処理で行われる式は以下のようなものになります 
  
  ```
  result_IN_00 = 0.5 * model_A_IN_00 + 0.3 * model_B_IN_00
  ```

## マルチマージ用コマンド入力窓

- 一行が一マージに対応します

- 基本は UI の設定を利用しますが、変更したいところだけ変数として入力するイメージです。

- 変数同士はカンマ `,` で区切る必要があります

### 使用可能な変数

- 使用可能な変数は以下の通りです

| 変数キーワード          | 説明                                                                             | 例                           |
| ---------------- | ------------------------------------------------------------------------------ | --------------------------- |
| O                | 出力ファイル名。サブディレクトリ指定可能。ディレクトリが無い場合・ファイルがあって上書き不可な場合、skipします。末尾にckpt記載がない場合、追加します | O=merge/test03/test-merge   |
| IN_[AB]_[00-11]  | INPUTブロックのマージ比率                                                                | IN_A_01=0.12345             |
| M_00             | MIDDLEブロックのマージ比率                                                               |                             |
| OUT_[AB]_[00-11] | OUTPUTブロックのマージ比率                                                               |                             |
| Model_A          | マージに使用するモデル名                                                                   | Model_A=sd-v1-5-pruned.ckpt |
| Model_B          | マージに使用するモデル名                                                                   | Model_B=sd-v1-5-pruned.ckpt |
| base_alpha       | 層別マージされない場所のマージ比率。A:(1-base_alpha), B:base_alpha です                            | base_alpha=1.0              |
| preset_weights   | プリセット名で指定(Model B のマージ比率になります。Model A には 1-B の値が入ります)                          | preset_weights=GRAD_V       |

- 例
  
  ```
  O=merge/test04/SD15-75-IN_00, IN_A_00=0.75
  Preset_Weights=ALL_A, O=merge/test06/SD15-WD13-2-8-OUT_11, OUT_A_11=0.2, OUT_B_11=0.8, Model_A=sd-v1-5-pruned, Model_B=wd-v1-3-float32
  ```

- 1 度に 25 段マージまではテスト済みです.

## 個人用プリセットファイル

- 個人用のプリセット保存用に、`csv/preset_own.tsv` を読み込むようにしました
   - このファイルは github には置かれませんので、勝手に更新されることはありません
   - 読み込みは、preset_own.tsv, preset.tsv の順番で行われます
   - `preset_own.tsv` には、以下の 2 つの列が必要です（タブ区切りです）
     ![](misc/each/each_01.png)
